;TV's server version 3.10
;Copyright (c) 2014 - 2019, Tycho Veltmeijer.
;All rights reserved.

entry Start

section '.text' executable code data readable writeable
include_usefile
include 'include/general_version_info.inc'
include 'windows/memfunctions.inc'
include 'windows/threadfunctions.inc'
include 'windows/modulefunctions.inc'
include 'windows/exceptions.inc'
include 'windows/user.inc'
include 'include/base.asm'
include 'windows/savedatatodisk.inc'
include 'windows/timedate.inc'
include 'windows/service_windows_nt.inc'

data import
library kernel32,'KERNEL32.DLL',\
        advapi32,'ADVAPI32.DLL',\
         user32,'USER32.DLL'

include 'API\KERNEL32.INC'
include 'API\USER32.INC'
include 'windows\adapted_ADVAPI32.INC'
end data

align 0x10
data resource
  directory RT_VERSION,versions,\
            24,manifest

  resource versions,\
           1,LANG_NEUTRAL,version

  versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
              'FileDescription',Description,\
              'LegalCopyright', Copyright,\
              'FileVersion',<ProductVersionPrefix, ".", FileVersion> ,\
              'ProductVersion',ProductVersion,\
              'OriginalFilename',FileName

  resource manifest,\
           1,LANG_NEUTRAL,mymanifest

  resdata mymanifest
    db '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'
    db '<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0" xmlns:asmv3="urn:schemas-microsoft-com:asm.v3">'
    db '<assemblyIdentity name="', Developer , '" processorArchitecture="', CPUArchitecture, '" version="' , ProductVersionManifest , '" type="win32"/>'
    db '<description>',Description,'</description>'
    db '<trustInfo xmlns="urn:schemas-microsoft-com:asm.v3">'
    db '<security>'
    db '<requestedPrivileges>'
    db '<requestedExecutionLevel level="requireAdministrator" uiAccess="false"/>'
    db '</requestedPrivileges>'
    db '</security></trustInfo>'
    db '<compatibility xmlns="urn:schemas-microsoft-com:compatibility.v1">'
    db '  <application>'
    db '    <!-- Windows Vista -->'
    db '    <supportedOS Id="{e2011457-1546-43c5-a5fe-008deee3d3f0}"/>'
    db '    <!-- Windows 7 -->'
    db '    <supportedOS Id="{35138b9a-5d96-4fbd-8e2d-a2440225f93a}"/>'
    db '    <!-- Windows 8 -->'
    db '    <supportedOS Id="{4a2f28e3-53b9-4441-ba9c-d69d4a4a6e38}"/>'
    db '    <!-- Windows 8.1 -->'
    db '    <supportedOS Id="{1f676c76-80e1-4239-95bb-83d0f6d0da78}"/>'
    db '    <!-- Windows 10 -->'
    db '    <supportedOS Id="{8e0f7a12-bfb3-4fe8-b9a5-48fd50a15a9a}"/>'
    db '  </application>'
    db '</compatibility>'
    db '</assembly>'
  endres
end data