
;TV's server version 3.10
;Copyright (c) 2014 - 2019, Tycho Veltmeijer.
;All rights reserved.
entry main

section '.text' code data readable writeable executable
dd 0x00000001 ;version (lowerword = new version, higherword=new functions but still supports older versions)
pointer __asm_exchange_tables
pointer RecvAndParseHTTP
pointer FreeHttpSession
pointer SendHTTPHeader
pointer ConvertEscapedCharactersToBytes
pointer GetIndexedStringItemWithHash
pointer EscapeAndSendValue_Export
pointer EscapeHtmlAndSendValue_Export
pointer DeleteDoubleSlashesInUrl
pointer DecodeURL
pointer SendFile
pointer getMimeTypeFromExtension
pointer FreeMemLocation;  ( = FreeMimeTypeFromExtension)

include_usefile
include 'include/general_version_info.inc'
include 'include/flags.inc'
include 'windows/register.inc'       ;HTTP protocol
include 'windows/callconvention.inc' ;HTTP protocol
include 'windows/timedate.inc'       ;HTTP protocol
include 'windows/fileFunctions.inc'  ;HTTP protocol
include 'windows/memfunctions.inc'
include 'include_http_protocol/tvs_server_http_protocol_base.asm'
include 'windows/threadfunctions.inc'
include 'windows/user.inc'
include 'include_http_protocol/plugin_export_list.inc'
include 'include_http_protocol/readable_writeable_data.inc'

data export
  export 'tvs_server_http_protocol_x64.DLL',\
         __asm_exchange_tables_c,'__asm_exchange_tables_http',\
         RecvAndParseHTTP_c, 'RecvAndParseHTTP',\
         FreeHttpSession_c, 'FreeHTTPSession',\
         SendHTTPHeader_c, 'SendHTTPHeader',\
         ConvertEscapedCharactersToBytes_c, 'ConvertEscapedCharactersToBytes',\
         GetIndexedStringItemWithHash_c,'GetCollectionItem',\
         EscapeAndSendValue_c,'EscapeAndSendValue',\
         EscapeHtmlAndSendValue_c,'EscapeHtmlAndSendValue',\
         DeleteDoubleSlashesInUrl_c,'DeleteDoubleSlashesInUrl',\
         DecodeURL_c,'DecodeURL',\
         SendFile_c,'SendFile';,\
         ;getMimeTypeFromExtension,'__GetMimeTypeFromExtension'
end data

data import
library kernel32,'KERNEL32.DLL',\
        advapi32,'ADVAPI32.DLL',\
        user32,'USER32.DLL'

include 'windows\adapted_KERNEL32.INC'
include 'API\ADVAPI32.INC'
include 'API\USER32.INC'
end data

align 0x10
data resource
  directory RT_VERSION,versions

  resource versions,\
           1,LANG_NEUTRAL,version

  versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
              'FileDescription',<"HTTP protocol parser ",CPUname>,\
              'LegalCopyright',Copyright,\
              'FileVersion',<ProductVersionPrefix, ".", FileVersion>,\
              'ProductVersion',ProductVersion
end data

section '.reloc' fixups data readable discardable