
;TV's server version 3.10
;Copyright (c) 2014 - 2019, Tycho Veltmeijer.
;All rights reserved.

EXCEPTION_BREAKPOINT equ 0x80000003
EXCEPTION_ACCESS_VIOLATION  equ 0xC0000005
EXCEPTION_ARRAY_BOUNDS_EXCEEDED  equ 0xC000008C
EXCEPTION_DATATYPE_MISALIGNMENT equ 0x80000002
EXCEPTION_FLT_DENORMAL_OPERAND equ 0xC000008D
EXCEPTION_FLT_DIVIDE_BY_ZERO equ 0xC000008E
EXCEPTION_FLT_INEXACT_RESULT equ 0xC000008F
EXCEPTION_FLT_INVALID_OPERATION equ 0xC0000090
EXCEPTION_FLT_OVERFLOW equ 0xC0000091
EXCEPTION_FLT_STACK_CHECK equ 0xC0000092
EXCEPTION_FLT_UNDERFLOW equ 0xC0000093
EXCEPTION_ILLEGAL_INSTRUCTION equ 0xC000001D
EXCEPTION_IN_PAGE_ERROR equ 0xC0000006
EXCEPTION_INT_DIVIDE_BY_ZERO equ 0xC0000094
EXCEPTION_INT_OVERFLOW equ 0xC0000095
EXCEPTION_INVALID_DISPOSITION equ 0xC0000026
EXCEPTION_NONCONTINUABLE_EXCEPTION equ 0xC0000025
EXCEPTION_PRIV_INSTRUCTION equ 0xC0000096
EXCEPTION_SINGLE_STEP equ 0x80000004
EXCEPTION_STACK_OVERFLOW equ 0xC00000FD

if used is32 & used setExceptionHandler
  _AddVectoredExceptionHandler db 'RtlAddVectoredExceptionHandler',0
  procAddVectoredExceptionHandler dd ?
end if

;typedef struct _CONTEXT {
;    DWORD ContextFlags;
;
;    DWORD   Dr0;
;    DWORD   Dr1;
;    DWORD   Dr2;
;    DWORD   Dr3;
;    DWORD   Dr6;
;    DWORD   Dr7;
;
;    DWORD   ControlWord;
;    DWORD   StatusWord;
;    DWORD   TagWord;
;    DWORD   ErrorOffset;
;    DWORD   ErrorSelector;
;    DWORD   DataOffset;
;    DWORD   DataSelector;
;    BYTE    RegisterArea[SIZE_OF_80387_REGISTERS];
;    DWORD   Cr0NpxState;
;
;    DWORD   SegGs;
;    DWORD   SegFs;
;    DWORD   SegEs;
;    DWORD   SegDs;
;
;    DWORD   Edi;
;    DWORD   Esi;
;    DWORD   Ebx;
;    DWORD   Edx;
;    DWORD   Ecx;
;    DWORD   Eax;
;
;
;    DWORD   Ebp;
;    DWORD   Eip;
;    DWORD   SegCs;              // MUST BE SANITIZED
;    DWORD   EFlags;             // MUST BE SANITIZED
;    DWORD   Esp;
;    DWORD   SegSs;
;
;    BYTE    ExtendedRegisters[MAXIMUM_SUPPORTED_EXTENSION];
;
;} CONTEXT;
;
;typedef struct DECLSPEC_ALIGN(16) _CONTEXT {
;
;    //
;    // Register parameter home addresses.
;    //
;    // N.B. These fields are for convience - they could be used to extend the
;    //      context record in the future.
;    //
;
;    DWORD64 P1Home;
;    DWORD64 P2Home;
;    DWORD64 P3Home;
;    DWORD64 P4Home;
;    DWORD64 P5Home;
;    DWORD64 P6Home;
;
;    //
;    // Control flags.
;    //
;
;    DWORD ContextFlags;
;    DWORD MxCsr;
;
;    //
;    // Segment Registers and processor flags.
;    //
;
;    WORD   SegCs;
;    WORD   SegDs;
;    WORD   SegEs;
;    WORD   SegFs;
;    WORD   SegGs;
;    WORD   SegSs;
;    DWORD EFlags;
;
;    //
;    // Debug registers
;    //
;
;    DWORD64 Dr0;
;    DWORD64 Dr1;
;    DWORD64 Dr2;
;    DWORD64 Dr3;
;    DWORD64 Dr6;
;    DWORD64 Dr7;
;
;    //
;    // Integer registers.
;    //
;
;    DWORD64 Rax;
;    DWORD64 Rcx;
;    DWORD64 Rdx;
;    DWORD64 Rbx;
;    DWORD64 Rsp;
;    DWORD64 Rbp;
;    DWORD64 Rsi;
;    DWORD64 Rdi;
;    DWORD64 R8;
;    DWORD64 R9;
;    DWORD64 R10;
;    DWORD64 R11;
;    DWORD64 R12;
;    DWORD64 R13;
;    DWORD64 R14;
;    DWORD64 R15;
;
;    //
;    // Program counter.
;    //
;
;    DWORD64 Rip;
;
;    //
;    // Floating point state.
;    //
;
;    union {
;        XMM_SAVE_AREA32 FltSave;
;        struct {
;            M128A Header[2];
;            M128A Legacy[8];
;            M128A Xmm0;
;            M128A Xmm1;
;            M128A Xmm2;
;            M128A Xmm3;
;            M128A Xmm4;
;            M128A Xmm5;
;            M128A Xmm6;
;            M128A Xmm7;
;            M128A Xmm8;
;            M128A Xmm9;
;            M128A Xmm10;
;            M128A Xmm11;
;            M128A Xmm12;
;            M128A Xmm13;
;            M128A Xmm14;
;            M128A Xmm15;
;        } DUMMYSTRUCTNAME;
;    } DUMMYUNIONNAME;
;
;    //
;    // Vector registers.
;    //
;
;    M128A VectorRegister[26];
;    DWORD64 VectorControl;
;
;    //
;    // Special debug control registers.
;    //
;
;    DWORD64 DebugControl;
;    DWORD64 LastBranchToRip;
;    DWORD64 LastBranchFromRip;
;    DWORD64 LastExceptionToRip;
;    DWORD64 LastExceptionFromRip;
;} CONTEXT, *PCONTEXT;
;
;typedef struct DECLSPEC_ALIGN(16) _M128A {
;    ULONGLONG Low;
;    LONGLONG High;
;} M128A, *PM128A;

;------------------------------------------------------------------------------
;This function handle exceptions and returns 0 when to kill the process and -1 to rerun the code.
;------------------------------------------------------------------------------
if used VectoredHandler
VectoredHandler:
call denter
MakeStack

;Get EXCEPTION_POINTERS from stack
if used is32
   mov ecx,dword [ebp+0x8]
end if


mov peax,pdword [pecx] ;ExceptionRecord
mov peax,pdword [pecx] ;ExceptionCode

;-cmp dword [peax],4000001Fh  ;STATUS_WX86_BREAKPOINT
;-je handleBreakPoint

;if ExceptionCode = EXCEPTION_ACCESS_VIOLATION
cmp dword [peax],EXCEPTION_ACCESS_VIOLATION
je handleAccesViolation

;if an int3 (breakpoint) exception occurd just continue.
cmp dword [peax],EXCEPTION_BREAKPOINT
jne showErr

handleBreakPoint:
;get context block from ExceptionInfo
mov pedi,pdword [pecx+psize]

;raise Eip by one (the size of the int3 command)
if used is64
   inc qword [rdi+(psize*6)+(2*4)+(6*2)+4+(6*psize)+(16*psize)]
else
   inc dword [edi+(psize*7)+(8*psize)+80+(psize*11)]
end if

;say to continue running the code
mov peax,-1
call dleave
ret (FunctionReturnFactor*1)

handleAccesViolation:

showErr:
;  push 0
;  push pdword [peax]
;  push 0x31
;  call CreateOneString
;
;  argpush 4,0x1000 or 0x40
;  argpush 3,0
;  argpush 2,peax
;  argpush 1,0
;  call [MessageBox]
;

;stop running the code
mov peax,0
call dleave
ret (FunctionReturnFactor*1)
end if

;------------------------------------------------------------------------------
;This function will set the handler if an exception occurs
;------------------------------------------------------------------------------
if used setExceptionHandler
setExceptionHandler:
call denter
MakeStack

if used is32
  ;Since function AddVectoredExceptionHandler was introduced in Windows XP, we need to use Getprocaddress to support Windows NT & 2000
  xor eax,eax
  cmp [procAddVectoredExceptionHandler],eax
  jne callAddVectoredExceptionHandler

  ;Getting the base addres of NTDLL.DLL from the TEB is faster than using LoadLibrary or GetModuleHandle and saves space (NTDLL.DLL string does not need to be defined).
  ;Renember, if you want to support Windows 9x (95, 98 & ME) this is NOT supported (your program WILL crash), use LoadLibrary instead
  mov eax, dword [fs:0x30]  ;fs points to the Thread enviorment block (TEB), +0x30 is pointer to Process envoirment block (PEB)
  mov eax, dword [eax+0xC]  ;0xC  = PEB_LDR_DATA
  mov eax, dword [eax+0x1C] ;0x1C = InInitOrderModuleList (LDR_MODULE), a linked list with loaded DLL's, the first one is always NTDLL.DLL
  mov eax, dword [eax+0x8]  ;0x8  = Base addres of NTDLL.DLL

  ;----------------------------------------------------------------------------------
  ;Get the address of function AddVectoredExceptionHandler (since it's directly
  ;redirected to NTDLL's function RTLAddVectoredExceptionHandler, we have to request
  ;this function, a request of AddVectoredExceptionHandler on kernel32.dll will fail)
  ;----------------------------------------------------------------------------------
  push _AddVectoredExceptionHandler
  push eax
  call [GetProcAddress]
  mov [procAddVectoredExceptionHandler],eax

  test eax,eax
  jz notSupportedAPI
end if

callAddVectoredExceptionHandler:
  argpush 2,VectoredHandler
  argpush 1,0
  if used is32
    ;Call the address gatherd by GetProcAddress
    call [procAddVectoredExceptionHandler]
  else
    ;x64 is supported since Windows XP, we don't have to worry about Windows NT support :) So call the one from the import table
    call [AddVectoredExceptionHandler]
  end if


notSupportedAPI:
call dleave
ret
end if